// This is a test class, where we can actually test all the data types.
/**Part of MdBase implemented in Java
 * Author Nikolaos Kotsis
 * Started Aug 1997
 * Copyright (c) University of strathclyde
*/

package strathclyde.cs.relational;
import strathclyde.cs.relational.operators.*;
import strathclyde.cs.relational.structured.*;
import strathclyde.cs.relational.atomic.*;
import java.util.*;
//import java.lang.*;
import java.io.*;

public class Display{
	 
		public static  void main (String argv[])
	{  go();
	  parse();
	}
	private static void parse()
	{	try{

		KParser K = new KParser(System.in,new Hashtable());
		K.statement();
	}
	catch(IOException e){System.out.println(e);}
	}
	public static void go(){
	    Tuple ta= new Tuple(2);
		Tuple tb= new Tuple(3);

	   Universal a=new Numeric(4.0),

			   a9=new Numeric(4.0),
			      b=new Numeric(9.0),
// This is a Triple constructor to test two Triples
				  aa=new Triple(5.0, 10.56, 15.5757),
			  	  bb=new Triple(7.0, 10.56, 13.5757),
				  ab1=new Numeric(45.56),
				  ab2=new Numeric(28.56),
// This is a Triple constructor to accept ordinary Numeric values
// first value =ordinary number,   second value=maximum error
			      aO=new Numeric(2.0),
				  bO=new Numeric(6.0);

		System.out.println("");
		System.out.println("This is a test for Numeric Types (value=double) ");
		System.out.println("");
		System.out.println(a +"  plus     "+ b +"  =  "  + a.plus(b).toString());
		System.out.println(b +"  plus     "+ a +"  =  "  + b.plus(a).toString());
		System.out.println(a +"  minus    "+ b +"  =  "  + a.minus(b).toString());
		System.out.println(a +"  times    "+ Universal.undefinedValue +"  =  "  + a.times(Universal.undefinedValue).toString());
		System.out.println(b +"  times    "+ a +"  =  "  + b.times(a).toString());
		System.out.println(a +"  divide   "+ b +"  =  "  + a.divide(b).toString());
		System.out.println(a +"    <      "+ b +"  =  "	 + a.lessthan(b));
		System.out.println(a +"    <      "+ a +"  =  "	 + a.lessthan(a));
		System.out.println(b +"    <      "+ a +"  =  "	 + b.lessthan(a));
		System.out.println(a +"    =      "+ b +"  =  "  + a.equals(b));
		System.out.println(a +"    =      "+ a +"  =  "  + a.equals(a));
			System.out.println("");
		//-------------- Text ---------------
		System.out.println("This is a test for Text data ");
		a = new Text("Paul Cockshott");
		b = new Text("DMcG");
		
		System.out.println("");
		System.out.println(a +"  plus     "+ b +"  =  "  + a.plus(b).toString());
		System.out.println(b +"  plus     "+ a +"  =  "  + b.plus(a).toString());
		System.out.println(a +"  minus    "+ b +"  =  "  + a.minus(b).toString());
		System.out.println(a +"  times    "+ Universal.undefinedValue +"  =  "  + a.times(Universal.undefinedValue).toString());
		System.out.println(b +"  times    "+ a +"  =  "  + b.times(a).toString());
		System.out.println(a +"  divide   "+ b +"  =  "  + a.divide(b).toString());
		System.out.println(a +"    <      "+ b +"  =  "	 + a.lessthan(b));
		System.out.println(a +"    <      "+ a +"  =  "	 + a.lessthan(a));
		System.out.println(b +"    <      "+ a +"  =  "	 + b.lessthan(a));
		System.out.println(a +"    =      "+ b +"  =  "  + a.equals(b));
		System.out.println(a +"    =      "+ a +"  =  "  + a.equals(a));
        // This is a test for Tuples	
		ta.field[0] = new Numeric(2); ta.field[1] = new Numeric(1); 
		tb.field[0] = new Numeric(7); tb.field[2] = new Numeric(20); tb.field[1] =new Numeric(12);	
		a=ta;b=tb;
		System.out.println("");
		System.out.println("This is a test for Tuples  ");
		System.out.println("");
		String raw="1952 William Paul Cockshott";
		Tuple wpc=new Tuple(raw, ' ');
		System.out.println(raw+" -> "+wpc+ " "+ wpc.arity());
		System.out.println(wpc +"  plus     "+ b +"  =  "  + wpc.plus(b).toString());
		System.out.println(b +"  plus     "+ a +"  =  "  + b.plus(a).toString());
		System.out.println(a +"  minus    "+ b +"  =  "  + a.minus(b).toString());
		System.out.println(a +"  times    "+ b +"  =  "  + a.times(b).toString());
		System.out.println(b +"  times    "+ a +"  =  "  + b.times(a).toString());
		System.out.println(wpc +"  divide   "+ b +"  =  "  + wpc.divide(b).toString());
		System.out.println(a +"    <      "+ b +"  =  "	 + a.lessthan(b));
		System.out.println(b +"    <      "+ a +"  =  "	 + b.lessthan(a));
		System.out.println(a +"    =      "+ b +"  =  "  + a.equals(b));
		System.out.println(a +"    =      "+ a +"  =  "  + a.equals(a));
		System.out.println(wpc +"    _    "+ aO +" =  "  + wpc.subscript(aO));
		System.out.println(wpc +"    _    "+ a  +" =  "  + wpc.subscript(a));
		System.out.println("");
		
	
		
		System.out.println("");
		System.out.println("This is a test for Reduce  ");
		System.out.println("");
		System.out.println(tb +"+ reduce" + tb.reduce(new Plus()));
		System.out.println(tb +"* reduce" + tb.reduce(new Times()));
		System.out.println(tb +"- reduce" + tb.reduce(new Minus()));
		System.out.println(tb +"/ reduce" + tb.reduce(new Divide()));
	//	System.out.println(tb +"- reducer" + tb.reducer(new Minus()));
	//	This is a test for the operators: Times, Plus, Divide, Minus.
		
		Plus aP=new Plus();
		Minus aM=new Minus();
		Times aT=new Times();
		Divide aD=new Divide();
		Equals aE=new Equals();
		LessThan aL=new LessThan();
		
		System.out.println("");
		System.out.println("This is a test for the Operators");
        System.out.println(" "+aO +  aP     + bO +"  =  "  + aP.apply(aO,bO).toString());
		System.out.println(" "+bO +  aP     + aO +"  =  "  + aP.apply(bO,aO).toString());
		System.out.println(" "+aO +  aM    + bO +"  =  "  + aM.apply(aO,bO).toString());
		System.out.println(" "+bO +  aM    + aO +"  =  "  + aM.apply(bO,aO).toString());
        System.out.println(" "+aO +  aT    + bO +"  =  "  + aT.apply(aO,bO).toString());
		System.out.println(" "+bO +  aT    + aO +"  =  "  + aT.apply(bO,aO).toString());
		System.out.println(" "+aO +  aD   + bO +"  =  "  + aD.apply(aO,bO).toString());
		System.out.println(" "+bO +  aD   + aO +"  =  "  + aD.apply(bO,aO).toString());
		System.out.println(" "+aO +         aL+ bO +"  =  "  + aL.apply(aO,bO));
		System.out.println(" "+bO +aL+ aO +"  =  "  + aL.apply(bO,aO));
		System.out.println(" "+aO +aE+ bO +"  =  "  + aE.apply(aO,bO));
		System.out.println(" "+bO +aE+ aO +"  =  "  + aE.apply(bO,aO));
	


	   
		// This is a test for the Composition
	    
		Divide divd=new Divide();
		MonadNegation newmnegation=new MonadNegation();
      	Dcomposed dc=new Dcomposed(divd,newmnegation);
		System.out.println("");
		System.out.println("This is a test for the Composition (u & n)");	
		System.out.println("The dyad (u)provided with the right argument (n) to produce a (monadic)");
		System.out.println("function (that is, a function whose dyadic case has an empty domain)");
		System.out.println("");
		System.out.println(" "+aO+dc+ bO +"  =  "  + dc.apply(aO,bO).toString());
		System.out.println("");
		System.out.println("This is a test for the MonadNegation");
		// This is a test for the MonadNegation
		
		System.out.println(aO+" (-) Negation =  "  + newmnegation.apply(aO).toString());
	
		//This is a test for the Carried-function
		Curried cd=new Curried((new Divide()),a);
		Curried cm=new Curried((new Minus()),a);		
		Curried cp=new Curried((new Plus()),a);
		Curried ct=new Curried((new Times()),a);		
	
		System.out.println("");
		System.out.println("This is a test for the Carried-function");	
		System.out.println(" "+b +cp +"  =  " + cp.apply(b).toString());
		System.out.println(" "+b +cm +"  =  " + ct.apply(b).toString());
		System.out.println(" "+b +cd +"  =  " + cd.apply(b).toString());
		System.out.println(" "+b +ct +"  =  " + cm.apply(b).toString());

// This is a test for the Suspend	
		System.out.println("");
		System.out.println("This is a test for delayed evaluation");	
	
		Suspended spp=new Suspended((new Plus()),a,b);
		Suspended spt=new Suspended((new Times()),a,b);
		Suspended spd=new Suspended((new Divide()),a,b);
		Suspended spmn=new Suspended((new Minus()),a,b);
		Suspended spm=new Suspended(newmnegation,aO);
		System.out.println("");
		System.out.println("This is a test for the Suspend");	
		System.out.println("eval("+spd +")  =  "  + spd.eval().toString());
		System.out.println("eval("+spmn +")  =  "  + spmn.eval().toString());
		System.out.println("eval("+spp +")  =  "  + spp.eval().toString());
		System.out.println("eval("+spt +")  =  "  + spt.eval().toString());
		System.out.println("eval("+spm+")  =  "  + spm.eval().toString());
		
		
// This is a test between two Triples
	   
		System.out.println("");
		System.out.println("This is a test for the operators between two Triples");
		System.out.println("");
		System.out.println(aa +"   plus     "+ bb +"  =  "  + aa.plus(bb).toString());
		System.out.println(aa +"  minus     "+ bb +"  =  "  + aa.minus(bb).toString());
		System.out.println(aa +"  times     "+ bb +"  =  "  + aa.times(bb).toString());
		System.out.println(aa +"  divide    "+ bb +"  =  "  + aa.divide(bb).toString());
		System.out.println(aa +"     <      "+ bb +"  =  "  + aa.lessthan(bb));
		System.out.println(aa +"     =      "+ aa +"  =  "  + aa.equals(bb));
	

// This is a test between a Triple and an ordinary number 
		
		System.out.println("This is a test for the operators between a Triple and an ordinary number");	
		System.out.println("");
		System.out.println(bb +"   plus     "+ ab1 +"  =  "  +bb.plus(ab1).toString());
		System.out.println(ab1 +"  minus     "+ bb+"  =  "  + ab1.minus(bb).toString());
		System.out.println(ab1 +"  times     "+ bb +"  =  "  + ab1.times(bb).toString());
		System.out.println(bb +"  divide    "+ ab2 +"  =  "  + bb.divide(ab2).toString());
		System.out.println(ab1 +"     <      "+ bb +"  =  "  + ab1.lessthan(bb));
		System.out.println(bb +"     =      "+ ab1 +"  =  "  + bb.equals(ab1));

// test of HashSets -----------------------------
		strathclyde.cs.relational.structured.HashSet HH= new strathclyde.cs.relational.structured.HashSet();
		HH.addmember(a);
		
		strathclyde.cs.relational.structured.HashSet H=new strathclyde.cs.relational.structured.HashSet();
		int i;
		for(i=0;i<3;i++)H.addmember(new Numeric(i));
		H.addmember(a);
		H.addmember(ab1);
	
		System.out.println("This is a test for Sets ");	
		System.out.println("");
		System.out.println(H +"   plus     "+ HH +"  =  "  +H.plus(HH));
		System.out.println(H +"  minus     "+ HH+"  =  "  + H.minus(HH));
		System.out.println(HH +"  minus     "+ H+"  =  "  + HH.minus(H));
		System.out.println(H +"  times     "+ HH +"  =  "  + H.times(HH));
		System.out.println(H+"  divide    "+ HH +"  =  "  + H.divide(HH));
		System.out.println(HH+"  divide    "+ H +"  =  "  + HH.divide(H));
		System.out.println(H +"     <      "+ HH +"  =  "  + H.lessthan(HH));
		System.out.println(HH +"     <      "+ H +"  =  "  + HH.lessthan(H));
		// form a curried function to test is something is less than 3
		Moperator is2 = new Curried(new Equals(), new Numeric(2));
		Moperator lessthan2 = new Curried(new LessThan(), new Numeric(45.56));
		System.out.println(H+"|"+lessthan2+"="+H.select(lessthan2));
		System.out.println(H+"|"+is2+"="+H.select(is2));
	
		//	System.out.println(H +"     =      "+ HH +"  =  "  + H.equals(HH));
		//System.out.println(" not a number "+Double.NaN);
		// --------------------- Relations----------------------
		// create a relation

		// create a set
			Relation R = new Hashrelation();
			Relation Q = new Hashrelation();
			// fill it with tuples
			
			R.addmember(new Tuple("Paul Cockshott CS",' '));
			R.addmember(new Tuple("Douglas McGregor CS",' '));
			R.addmember(new Tuple("John Wilson CS",' '));
			R.addmember(new Tuple("John Gilchrist PS",' '));
			R.addmember(new Tuple("Nikos Kotsis CS",' '));
			Q.addmember(new Tuple("PS,23,Newton Place",','));
			Q.addmember(new Tuple("PS,23,Newton Place",','));
			Q.addmember(new Tuple("RO,10,Livingston Tower",','));
			System.out.println("Test of Set of Tuples ");
			System.out.println("Here is the set R="+R);
			Moperator Field0 = new Curried(new Subscript(),new Numeric(0));
			Moperator lessthanpaul = new Curried(Doperator.LT, new Text("Paul"));
			Moperator isjohn = new Curried(Doperator.EQ, new Text("John"));
			Moperator Field0ltp = new Mcomposed(lessthanpaul,Field0);
			Moperator Field0John = new Mcomposed(isjohn,Field0);
			Moperator Field2 = new Curried(new Subscript(), new Numeric(2));

			Tuple t01 = new Tuple("0,1",',');
			Moperator sub01 = new Curried(new Subscript(),t01);
			Doperator compose = new Dcomposed(sub01,new Concat());
			Doperator equi = new Dcomposed(Field2,Doperator.EQ,Field0);
			Doperator equijoin = new Join(compose,equi);
			System.out.println("R|"+Field0ltp+"="+R.select(Field0ltp));
			System.out.println("R|"+Field0John+"="+R.select(Field0John));
			System.out.println("");
			System.out.println(" Test of Join");
			System.out.println("Here is the set Q:"+Q);
			System.out.println("R "+equijoin +" Q =");
			System.out.println(equijoin.apply(R,Q));
		    System.out.println("");
			System.out.println(" Test of Projection");
			Tuple tp= new Tuple(2);
			tp.field[0] = new Numeric(0); tp.field[1] = new Numeric(2); 
			System.out.println("Here is the set R:"+R);
			System.out.println("");
			System.out.println("Projection of 1st and 3rd field of tuples in R is:");

			System.out.println(R.project(tp));
			System.out.println(R.project(new Numeric(1)));
			R=new Hashrelation(new Tuple("0,1",','));// relation with primary key
			R.addmember(new Tuple("Paul Cockshott CS",' '));
			R.addmember(new Tuple("Douglas McGregor CS",' '));
			R.addmember(new Tuple("John Wilson CS",' '));
			R.addmember(new Tuple("John Gilchrist PS",' '));
			R.addmember(new Tuple("Nikos Kotsis CS",' '));
			System.out.println("Test of relation with primary key ");
			System.out.println("Here is the set R="+R);
		
		}

}
