
/*
 *
 * divide
 * Part of MdBase implemented in Java
  Author Nikos Kotsis
  Started Aug 1997
  Copyright (c) University of strathclyde
 */
package strathclyde.cs.relational.atomic;
import strathclyde.cs.relational.*;
import strathclyde.cs.relational.structured.*;

public class Triple extends Numeric {
	private double inf,sup;
	

	public Triple (Numeric b){
		inf=b.inf();
		value=b.main();
		sup=b.sup();
	}
	public Triple (double e1,double e2,double e3) 
		throws  ArithmeticException{
		if (e1>e2 || e2>e3) throw new ArithmeticException("Not a valid Interval");
		else{ 
			inf=e1;
			value=e2;
			sup=e3;
			}
	}
	public double inf(){return inf;}

	public double sup(){return sup;}

	public Universal plus (Universal b){
		if(b instanceof Interval){
			Interval t=(Interval)b;
			return new Triple(inf + t.inf(), value + t.main(), sup + t.sup());
		}else{
			return undefinedValue;
		}
	}
	public Universal minus (Universal b){
	if(b instanceof Interval){
			Interval t=(Interval)b;
			return new Triple(inf - t.sup(), value - t.main(), sup-t.inf());
		}else{
			return undefinedValue;
		}
	}
	public Universal times (Universal b){
		if(b instanceof Interval){
			Interval t=(Interval)b;
			if (inf>=0 && sup>=0 && t.inf()>=0 && t.sup()>=0)
				return new Triple(inf*t.inf(), value*t.main(), sup*t.sup());
			
			if (inf>=0 && sup>=0 && t.inf()<0 && t.sup()>=0)
				return new Triple(sup*t.inf(), value*t.main(), sup*t.sup());
			
			if (inf>=0 && sup>=0 && t.inf()<0 && t.sup()<0)
				return new Triple(sup*t.inf(), value*t.main(), inf*t.sup());
			
			if (inf<0 && sup>=0 && t.inf()>=0 && t.sup()>=0)
				return new Triple(inf*t.sup(), value*t.main(), sup*t.inf());
			
				/*if (inf<0 && sup>=0 && t.inf()<0 && t.sup()>=0)
				if inf*t.inf()>sup*sup() return max=inf*t.inf() else max=sup*sup()
				if inf*t.sup()>sup*t.inf() return 
				return new Triple(min(inf*t.sup(), value*t.main(), sup*t.inf()));
			*/
			if (inf<0 && sup>=0 && t.inf()<0 && t.sup()<0)
				return new Triple(sup*t.inf(), value*t.main(), inf*t.inf());
			
			if (inf<0 && sup<0 && t.inf()>=0 && t.sup()>=0)
				return new Triple(inf*t.sup(), value*t.main(), sup*t.inf());
			
			if (inf<0 && sup<0 && t.inf()<0 && t.sup()>=0)
				return new Triple(inf*t.sup(), value*t.main(), inf*t.inf());
			
			if (inf<0 && sup<0 && t.inf()<0 && t.sup()<0)
				return new Triple(sup*t.sup(), value*t.main(), inf*t.inf());

			throw new RuntimeException("Error in Times operation of Triplex"); 

		}else{
			return undefinedValue;
		}
	}
	public  Universal divide (Universal b){
		if(b instanceof Interval){
			Interval t=(Interval)b;		
			if (inf>=0 && sup>=0 && t.inf()>0 && t.sup()>0)
				return new Triple(inf/t.sup(), value/t.main(), sup/t.inf());
				
			if (inf>=0 && sup>=0 && t.inf()<0 && t.sup()<0)
				return new Triple(sup/t.sup(), value/t.main(), inf/t.inf());
		
			if (inf<0 && sup>=0 && t.inf()>0 && t.sup()>0)
				return new Triple(inf/t.inf(), value/t.main(), sup/t.inf());
			
			if (inf<0 && sup>=0 && t.inf()<0 && t.sup()<0)
				return new Triple(sup/t.sup(), value/t.main(),inf/t.sup());

			if (inf<0 && sup<0 && t.inf()>0 && t.sup()>0)
				return new Triple(inf/t.inf(), value/t.main(),sup/t.sup());

			if (inf<0 && sup<0 && t.inf()<0 && t.sup()<0)
				return new Triple(sup/t.inf(), value/t.main(),inf/t.sup());

			throw new RuntimeException("Error in Divide operation of Triplex"); 
			}else{
				return undefinedValue;
				
			}
		}
		public  boolean equals (Object b){
		if(b instanceof Interval){
			Interval t=(Interval)b;
				return (inf==t.inf() && value==t.main() && sup==t.sup());
			} else {
			return false;
		}
	}
		public  boolean lessthan (Universal b){
			if(b instanceof Interval){
			Interval t=(Interval)b;		
				return (sup<t.inf());
			} else {
			return false;
		}
	}
		public Universal divmod (Universal b){return undefinedValue;}
		
	
	  public String toString (){
			
		//	System.out.print("" );
	     return " "+ inf + "" + value + ""+ sup + " " ;		
	}
}
