//package operator;



/*
*The dyad (u)provided with the right argument (n) to produce a (monadic)function, 
*(that is, a function whose dyadic case has an empty domain)");
* Dcomposed
* *
Part of Mbase implemented in Java
Author Paul Cockshott
Started Aug 1997
Copyright (c) University of strathclyde

  
*/

package strathclyde.cs.relational.operators;
import strathclyde.cs.relational.*;
public class Dcomposed extends Doperator

{  
	
	
	private Moperator op2,op3;
	private Doperator op1;
	private int sides;
	
	public Dcomposed(Doperator o1,Moperator o2)
	{ op2=o2;op1=o1;sides=1;}
	public Dcomposed(Moperator o2,Doperator o1)
	{ op2=o2;op1=o1;sides=2;}	
	public Dcomposed(Moperator o2,Doperator o1, Moperator o3)
	{ op2=o2;op1=o1;op3=o3;sides=3;}
	public Universal apply(Universal a, Universal b)
	{ 
		if(sides==1)return op1.apply(a,op2.apply(b));
		if(sides==2)return op1.apply(op2.apply(a),b);
		else return op1.apply(op2.apply(a),op3.apply(b));
	}
	public String toString()
	{
		if(sides==1)return "("+op1+"&("+op2+"))";
		if(sides==2){return "(("+op2+")&"+op1+")";}
		else return "(("+op2+")&"+op1+"&("+op3+"))";
	}
	
	
}
