/**TeX

  
	
	  {\bf LoadRelation}\footnote{Part of MdBase implemented in Java
 Author Nikolaos Kotsis
 Started September 1997
 Copyright \copyright University of Strathclyde}
 is a monadic operator whose syntactic representation in K is
 the dollar sign and whose signiture is given as follows:

 \begin{tabular}{|l|l|l|}
 Syntax	&Type							&Meaning \cr\hline
\$ x	&$(String\rightarrow relation)	$&x is a filename\cr
        &                               &containing ',' separated\cr
		&                               &fields to be loaded as a relation\cr
\hline
\$ [x,[i,j,...]]&$([String,*int]\rightarrow relation)$ & x as above\cr
                &                                      & i,j,.. key fields\cr
				\hline
 \end{tabular}
is a 
*/

package strathclyde.cs.relational.operators;
import java.io.*;
import java.util.*;
import strathclyde.cs.relational.*;
import strathclyde.cs.relational.structured.*;
import strathclyde.cs.relational.atomic.*;




public class LoadRelation extends Moperator

{
	
	   public Universal apply(Universal b){
		   
	   /**TeX
	   If the parameter is a text string interpret this
	   as the name of a comma separated file of text
		   to be loaded with no primary key */
		   Relation R= new Hashrelation();
		   String inputString=b.toString();
		   if(b instanceof Tuple){
		   /**Tex if the parameter is a tuple [x,y]
			   then x is the filename and y a tuple of the key fields */
			   Universal x= ((Tuple)b).subscript(0);
			   Universal y= ((Tuple)b).subscript(1);
			   if(y instanceof Universal){
				   R=new Hashrelation((Universal)y);
				   inputString=x.toString();
			   }
		   }
		   try{
			   
			   FileInputStream inputFile =new FileInputStream(inputString);		
			   DataInputStream dataIn = new DataInputStream (inputFile);	
			   while(true){
				   String line=dataIn.readLine();
				   
				   if(line !=null){					
					   Tuple tupleline=new Tuple(line,',');
					   R.addmember(tupleline);					
				   }else{
					   break;
				   }				
			   }	
		   }		
		   catch (FileNotFoundException e){
			   System.out.println(e);
		   }
		   catch(IOException e){
			   System.out.println(e);
		   }		
		   return R;
		   
		   
		   
		   
	   }
}

/*StreamTokenizer tokens= new StreamTokenizer (inputFile);
tokens.quoteChar((int)'"');
tokens.eolIsSignificant(true);
Vector v=new Vector();
while(tokens.nextToken()!=tokens.TT_EOF){
String line=tokens.sval;

  if (tokens.nextToken()==tokens.TT_EOL){}
  else{line=tokens.sval;tokens.nextToken();}
  v.addElement(line);
System.out.println(v);*/